/* $Id: recipe_main.c,v 1.9 2011/07/11 13:30:52 llundin Exp $
 *
 * This file is part of the VISIR Pipeline
 * Copyright (C) 2002,2003 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02111-1307  USA
 */

/*
 * $Author: llundin $
 * $Date: 2011/07/11 13:30:52 $
 * $Revision: 1.9 $
 * $Name: isaac-6_1_3 $
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/*-----------------------------------------------------------------------------
                                Includes
 -----------------------------------------------------------------------------*/

#include <cpl.h>

#include <irplib_plugin.h>


/*----------------------------------------------------------------------------*/
/**
 * @defgroup recipe_main   General plugin tests
 */
/*----------------------------------------------------------------------------*/

/**@{*/

/*-----------------------------------------------------------------------------
                            Function definitions
 -----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*/
/**
  @brief    Find a plugin and submit it to some tests
  @return   0 iff succesful

 */
/*----------------------------------------------------------------------------*/
int main(void)
{

    const char * tags[] = {
        "CALPRO_OH_CATALOG",
        "CALPRO_OH_CATALOG",
        "CALPRO_OH_CATALOG",
        "CALPRO_OH_CATALOG",
        "CALPRO_OH_CATALOG",
        "CALPRO_XE_CATALOG",
        "CALPRO_XE_CATALOG",
        "CALPRO_XE_CATALOG",
        "CALPRO_XE_CATALOG",
        "CALPRO_XE_CATALOG",
        "CALPRO_AR_CATALOG",
        "CALPRO_AR_CATALOG",
        "CALPRO_AR_CATALOG",
        "CALPRO_AR_CATALOG",
        "CALPRO_AR_CATALOG",
        "SEDS",
        "SEDS",
        "SEDS",
        "SEDS",
        "SEDS",
        "STDSTARS_CATS",
        "STDSTARS_CATS",
        "STDSTARS_CATS",
        "STDSTARS_CATS",
        "STDSTARS_CATS",
        "MASTER_IMG_FLAT",
        "MASTER_IMG_FLAT",
        "MASTER_IMG_FLAT",
        "MASTER_IMG_FLAT",
        "MASTER_IMG_FLAT",
        "MASTER_BPM",
        "MASTER_BPM",
        "MASTER_BPM",
        "MASTER_BPM",
        "MASTER_BPM",
        "MASTER_DARK",
        "MASTER_DARK",
        "MASTER_DARK",
        "MASTER_DARK",
        "MASTER_DARK",
        "DETLIN_A",
        "DETLIN_A",
        "DETLIN_A",
        "DETLIN_A",
        "DETLIN_A",
        "DETLIN_B",
        "DETLIN_B",
        "DETLIN_B",
        "DETLIN_B",
        "DETLIN_B",
        "DETLIN_C",
        "DETLIN_C",
        "DETLIN_C",
        "DETLIN_C",
        "DETLIN_C",
        "MASTER_SP_FLAT",
        "MASTER_SP_FLAT",
        "MASTER_SP_FLAT",
        "MASTER_SP_FLAT",
        "MASTER_SP_FLAT",
        "LW_MASTER_SP_FLAT",
        "LW_MASTER_SP_FLAT",
        "LW_MASTER_SP_FLAT",
        "LW_MASTER_SP_FLAT",
        "LW_MASTER_SP_FLAT",
        "ARC_COEF",
        "ARC_COEF",
        "ARC_COEF",
        "ARC_COEF",
        "ARC_COEF",
        "LW_ARC_COEF",
        "LW_ARC_COEF",
        "LW_ARC_COEF",
        "LW_ARC_COEF",
        "LW_ARC_COEF",
        "STAR_TRACE_COEF",
        "STAR_TRACE_COEF",
        "STAR_TRACE_COEF",
        "STAR_TRACE_COEF",
        "STAR_TRACE_COEF",
        "LW_STAR_TRACE_COEF",
        "LW_STAR_TRACE_COEF",
        "LW_STAR_TRACE_COEF",
        "LW_STAR_TRACE_COEF",
        "LW_STAR_TRACE_COEF",
        "IM_ACQ",
        "IM_ACQ",
        "IM_ACQ",
        "IM_ACQ",
        "IM_ACQ",
        "TEST_FRAME",
        "TEST_FRAME",
        "TEST_FRAME",
        "TEST_FRAME",
        "TEST_FRAME",
        "IM_ILLUM",
        "IM_ILLUM",
        "IM_ILLUM",
        "IM_ILLUM",
        "IM_ILLUM",
        "LINEAR_LAMP",
        "LINEAR_LAMP",
        "LINEAR_LAMP",
        "LINEAR_LAMP",
        "LINEAR_LAMP",
        "LINEAR_DARK",
        "LINEAR_DARK",
        "LINEAR_DARK",
        "LINEAR_DARK",
        "LINEAR_DARK",
        "SLIT_IMG",
        "SLIT_IMG",
        "SLIT_IMG",
        "SLIT_IMG",
        "SLIT_IMG",
        "SLIT_IMG_CAL",
        "SLIT_IMG_CAL",
        "SLIT_IMG_CAL",
        "SLIT_IMG_CAL",
        "SLIT_IMG_CAL",
        "IM_ZPOINT",
        "IM_ZPOINT",
        "IM_ZPOINT",
        "IM_ZPOINT",
        "IM_ZPOINT",
        "IM_CHOPPING_CAL",
        "IM_CHOPPING_CAL",
        "IM_CHOPPING_CAL",
        "IM_CHOPPING_CAL",
        "IM_CHOPPING_CAL",
        "POL_FLAT",
        "POL_FLAT",
        "POL_FLAT",
        "POL_FLAT",
        "POL_FLAT",
        "IM_FLAT",
        "IM_FLAT",
        "IM_FLAT",
        "IM_FLAT",
        "IM_FLAT",
        "IM_DARK",
        "IM_DARK",
        "IM_DARK",
        "IM_DARK",
        "IM_DARK",
        "SP_ARC",
        "SP_ARC",
        "SP_ARC",
        "SP_ARC",
        "SP_ARC",
        "SP_FLAT",
        "SP_FLAT",
        "SP_FLAT",
        "SP_FLAT",
        "SP_FLAT",
        "IM_STARTRACE",
        "IM_STARTRACE",
        "IM_STARTRACE",
        "IM_STARTRACE",
        "IM_STARTRACE",
        "SP_STARTRACE",
        "SP_STARTRACE",
        "SP_STARTRACE",
        "SP_STARTRACE",
        "SP_STARTRACE",
        "SP_CHOPPING",
        "SP_CHOPPING",
        "SP_CHOPPING",
        "SP_CHOPPING",
        "SP_CHOPPING",
        "SP_CHOPPING_CAL",
        "SP_CHOPPING_CAL",
        "SP_CHOPPING_CAL",
        "SP_CHOPPING_CAL",
        "SP_CHOPPING_CAL",
        "SP_NODDINGOBJ",
        "SP_NODDINGOBJ",
        "SP_NODDINGOBJ",
        "SP_NODDINGOBJ",
        "SP_NODDINGOBJ",
        "SP_NODDINGSKY",
        "SP_NODDINGSKY",
        "SP_NODDINGSKY",
        "SP_NODDINGSKY",
        "SP_NODDINGSKY",
        "SP_NODDING_CAL",
        "SP_NODDING_CAL",
        "SP_NODDING_CAL",
        "SP_NODDING_CAL",
        "SP_NODDING_CAL",
        "SP_NODDING_CALOBJ",
        "SP_NODDING_CALOBJ",
        "SP_NODDING_CALOBJ",
        "SP_NODDING_CALOBJ",
        "SP_NODDING_CALOBJ",
        "SP_NODDING_CALSKY",
        "SP_NODDING_CALSKY",
        "SP_NODDING_CALSKY",
        "SP_NODDING_CALSKY",
        "SP_NODDING_CALSKY",
        "SP_NODDING_FLUX",
        "SP_NODDING_FLUX",
        "SP_NODDING_FLUX",
        "SP_NODDING_FLUX",
        "SP_NODDING_FLUX",
        "IM_JITTEROBJ",
        "IM_JITTEROBJ",
        "IM_JITTEROBJ",
        "IM_JITTEROBJ",
        "IM_JITTEROBJ",
        "IM_JITTERSKY",
        "IM_JITTERSKY",
        "IM_JITTERSKY",
        "IM_JITTERSKY",
        "IM_JITTERSKY",
        "IM_CHOPPING",
        "IM_CHOPPING",
        "IM_CHOPPING",
        "IM_CHOPPING",
        "IM_CHOPPING",
        "SED",
        "SED",
        "SED",
        "SED",
        "SED",
        "STDSTAR_CAT",
        "STDSTAR_CAT",
        "STDSTAR_CAT",
        "STDSTAR_CAT",
        "STDSTAR_CAT",
        "CATALOG",
        "CATALOG",
        "CATALOG",
        "CATALOG",
        "CATALOG",
    };

    cpl_pluginlist * pluginlist;
    const size_t ntags = sizeof(tags) / sizeof(char*);

    cpl_test_init(PACKAGE_BUGREPORT, CPL_MSG_WARNING);

    pluginlist = cpl_pluginlist_new();

    cpl_test_zero(cpl_plugin_get_info(pluginlist));

    /* FIXME: Remove plugins when they have been fixed */
    if (cpl_pluginlist_find(pluginlist, "isaac_img_dark") ||
        cpl_pluginlist_find(pluginlist, "isaac_img_detlin") ||
        cpl_pluginlist_find(pluginlist, "isaac_img_slitpos") ||
        cpl_pluginlist_find(pluginlist, "isaac_img_twflat") ||
        cpl_pluginlist_find(pluginlist, "isaac_spc_flat") ||
        cpl_pluginlist_find(pluginlist, "isaac_spc_wlcalib") ||
        cpl_pluginlist_find(pluginlist, "isaac_spc_wlmodel") ||
        cpl_pluginlist_find(pluginlist, "isaac_util_genlines") ||
        cpl_pluginlist_find(pluginlist, "isaac_util_stdstars")) {

        cpl_msg_warning(cpl_func, "Skipping test of %d plugin(s):",
                        cpl_pluginlist_get_size(pluginlist));
        if (cpl_msg_get_level() <= CPL_MSG_INFO)
            cpl_pluginlist_dump(pluginlist, stdout);
    } else {
        cpl_test_zero(irplib_plugin_test(pluginlist, ntags, tags));
    }

    cpl_pluginlist_delete(pluginlist);

    return cpl_test_end(0);
}

/**@}*/
